import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;
import java.text.*;

// fan om jag fr denna att funka allts...


/** Skter mlningen av cellerna i tabellen */
public class LoggfilTableCellRenderer implements TableCellRenderer {
    
    private JLabel lblOutput = new JLabel("OPEN");
    Font fonten;
    Font fonten2;
    String s = new String("");
    Calendar cal;
    
    LoggfilTableCellRenderer() {
        
        fonten = lblOutput.getFont();
        // lite tympligt det hr, men jag fr iaf standardvrdena p en font (fast jag stter plain istllet d)
        fonten2 = new Font(fonten.getName(), Font.PLAIN, fonten.getSize());
        lblOutput.setFont(fonten2);
        lblOutput.setOpaque(true);
        
    }
    
    /** "Returns the component used for drawing the cell. This method is used to configure the renderer appropriately before
     * drawing."
     * @param table the JTable that is asking the renderer to draw; can be null
     * @param value the value of the cell to be rendered. It is up to the specific renderer to interpret and draw the value. For example, if value is the string "true", it could be rendered as a string or it could be rendered as a check box that is checked. null is a valid value
     * @param isSelected true if the cell is to be rendered with the selection highlighted; otherwise false
     * @param hasFocus if true, render cell appropriately. For example, put a special border on the cell, if the cell can be edited, render in the color used to indicate editing
     * @param row the row index of the cell being drawn. When drawing the header, the value of row is -1
     * @param column the row index of the cell being drawn. When drawing the header, the value of row is -1
     * @return the component used for drawing the cell
     */    
    public java.awt.Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
        
        // frsk til frg beroende p om kolumn r vald fr sortering
        // knns vldigt fel detta, men funkar det s r det ju alltid nt
        TableColumn tc;
        boolean isSorted = false;
        tc = table.getColumnModel().getColumn(column);
        if (((String) tc.getHeaderValue()).endsWith(" v") || ((String) tc.getHeaderValue()).endsWith(" ^")) {
            isSorted = true;
        }
        
        // frg ska vara rd om ACTION = DROP, annars grn
        if (table.getValueAt(row, 2).equals("DROP") ) {
            if (isSorted)
                lblOutput.setBackground(LoggfilGrafik.getColorBakgrundDROPsorted());
            else
                lblOutput.setBackground(LoggfilGrafik.getColorBakgrundDROP());
        } else {
            if (isSorted)
                lblOutput.setBackground(LoggfilGrafik.getColorBakgrundSUCCESSFULsorted());
            else
                lblOutput.setBackground(LoggfilGrafik.getColorBakgrundSUCCESSFUL());
        }
        
        // gr inte att bara gra om till string om det r t.ex. java.util.date eller andra knasiga prylar
        if (value instanceof Date) {
            lblOutput.setText( DateFormat.getDateTimeInstance().format( (Date) value) );
        } else if (value instanceof Integer) {
            // r integern -1 s ska "-" skrivas ut istllet (eller bara ingenting..? ska klura lite..)
            if ( ((Integer) value).equals( new Integer(-1) ) ) {
                lblOutput.setText( "-" );
            } else {
                lblOutput.setText( ((Integer) value).toString() );
            }
            
            //lblOutput.setText(  ((Integer) value).toString()  );
        } else {
            lblOutput.setText( (String) value );
        }
        
        return lblOutput;
    }
    
    //getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
}